<script setup>
// ----------------------------------------------------------------
// Imports
// ----------------------------------------------------------------

// To see the list of imports, copy the final content of option (after setup) into the site:
// https://vue-echarts.dev/#codegen
import { PieChart } from "echarts/charts";
import {
  LegendComponent,
  ToolboxComponent,
  TooltipComponent,
} from "echarts/components";
import { use } from "echarts/core";
import { CanvasRenderer } from "echarts/renderers";
import { provide, ref } from "vue";
import VChart, { THEME_KEY } from "vue-echarts";

const props = defineProps({
  data: {
    type: Object,
    required: true,
  },
});

use([
  TooltipComponent,
  ToolboxComponent,
  LegendComponent,
  PieChart,
  CanvasRenderer,
]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const loading = ref(true);
const option = ref({
  tooltip: {
    trigger: "item",
  },
  toolbox: {
    show: true,
    feature: {
      saveAsImage: {},
    },
  },
  legend: {
    top: "5%",
    left: "center",
  },
  series: [
    {
      type: "pie",
      radius: ["40%", "70%"],
      avoidLabelOverlap: false,
      padAngle: 5,
      itemStyle: {
        borderRadius: 10,
      },
      label: {
        show: false,
        position: "center",
      },
      emphasis: {
        label: {
          show: true,
          fontSize: 40,
          fontWeight: "bold",
        },
      },
      labelLine: {
        show: false,
      },
      data: [],
    },
  ],
});

option.value.series[0].data = convertDictFormat(props.data);
loading.value = false;

// ----------------------------------------------------------------
// Function
// ----------------------------------------------------------------

function convertDictFormat(originalObj) {
  const transformedArray = [];
  for (const key in originalObj) {
    const value = originalObj[key];

    if ("color" in value) {
      transformedArray.push({
        value: value.count,
        name: key,
        itemStyle: { color: value.color },
      });
    } else {
      transformedArray.push({ value: value.count, name: key });
    }
  }
  return transformedArray;
}

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------
watch(
  () => props.data,
  async () => {
    if (props.data !== null) {
      option.value.series[0].data = convertDictFormat(props.data);
      loading.value = false;
    }
  },
);

provide(THEME_KEY, "light");
</script>

<template>
  <VChart
    class="chart"
    :option="option"
    :loading="loading"
  />
</template>

<style scoped>
.chart {
  height: 300px;
  width: 100%;
}
</style>
